import org.junit.Assert;
import org.junit.Test;

import java.util.ArrayList;

public class MyArrayListTest {

    @Test
    public void addMethod(){
        MyArrayList<Integer> arrLst = new MyArrayList<>();
        arrLst.add(new Integer(10));
        Assert.assertEquals(1, arrLst.size());
    }

    @Test
    public void addMethod02(){
        MyArrayList<Integer> arrLst = new MyArrayList<>();
        arrLst.add(5, 3);
        int actual = arrLst.get(3);
        Assert.assertEquals(5, actual);
    }

    @Test
    public void testConstructor(){
        MyArrayList<Integer> arrLst = new MyArrayList<>(10);
        arrLst.add(10);
        int actual = arrLst.get(10);
        Assert.assertEquals(10, actual);
    }

    @Test
    public void testRemoveSize(){
        MyArrayList<Integer> arrList = new MyArrayList<>();
        int expect = 0;
        arrList.add(10);

        arrList.remove(0);
        Assert.assertEquals(expect, arrList.size());
    }

    @Test(expected = ArrayIndexOutOfBoundsException.class)
    public void testRemoveElem(){
        MyArrayList<Integer> arrList = new MyArrayList<>();
        int expect = 0;
        arrList.add(10);
        int actual = arrList.get(0);
        Assert.assertEquals(10, actual);
        arrList.remove(0);
        actual = arrList.get(0);
    }

    @Test
    public void testSetElement(){
        MyArrayList<Integer> arrList = new MyArrayList<>(10);
        arrList.add(10, 3);
        int expect = 10;
        int actual = arrList.get(3);
        Assert.assertEquals(expect, actual);
        arrList.set(11, 3);
        expect = 11;
        actual = arrList.get(3);
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void testClear(){
        MyArrayList<Integer> arrList = new MyArrayList<>();
        for(int i = 0; i < 10; i ++){
            arrList.add(i);
        }
        int expect = 10;
        int actual = arrList.size();
        Assert.assertEquals(expect, actual);
        arrList.clear();
        expect = 0;
        actual = arrList.size();
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void isEmptyTestPass(){
        MyArrayList<Integer> arrList = new MyArrayList<>();
        Assert.assertTrue(arrList.isEmpty());
    }

    @Test
    public void isEmptyTestFail(){
        MyArrayList<Integer> arrList = new MyArrayList<>();
        for(int i = 0; i < 10; i ++){
            arrList.add(i);
        }
        Assert.assertFalse(arrList.isEmpty());
    }

    @Test
    public void containsTestPass(){
        MyArrayList<Integer> arrList = new MyArrayList<>();
        arrList.add(10);
        Assert.assertTrue(arrList.contains(10));
    }

    @Test
    public void containsTestFail(){
        MyArrayList<Integer> arrList = new MyArrayList<>();
        Assert.assertFalse(arrList.contains(10));
    }

    @Test
    public void removeRangTest(){
        MyArrayList<Integer> arrList = new MyArrayList<>();
        for(int i = 0; i < 10; i ++){
            arrList.add(i);
        }
        int expect = 10;
        int actual = arrList.size();
        Assert.assertEquals(expect, actual);
        arrList.removeRange(0, 2);
        expect = 7;
        actual = arrList.size();
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void toArray(){
        MyArrayList<Integer> arrList = new MyArrayList<>();
        arrList.add(10);
        arrList.add(10);
        arrList.add(10);

        Integer[] temp = arrList.toArray(new Integer[arrList.size()]);

        int expect = 3;
        int actual = temp.length;

        Assert.assertEquals(expect, actual);
    }
}
