import org.junit.Assert;
import org.junit.Test;

import java.util.Arrays;

public class MyMapTest {

    @Test
    public void testPut(){
        MyMap<String, String> map = new MyMap<>();
        map.put("jonathan", "hinds");
        Assert.assertTrue(map.size() == 1);
    }

    @Test
    public void testPutMultiples(){
        MyMap<String, String> map = new MyMap<>();
        map.put("jonathan", "hinds");
        map.put("jonathan", "daniel");
        System.out.println(map.size());
        Assert.assertTrue(map.size() == 1);
    }

    @Test
    public void testGetMethod(){
        MyMap<String, String> map = new MyMap<>();
        map.put("jonathan", "hinds");
        String expect = "hinds";
        String actual = map.get("jonathan");
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void testRemove(){
        MyMap<String, String> map = new MyMap<>();
        map.put("jonathan", "hinds");
        map.remove("jonathan");
        System.out.println(map.size());
        Assert.assertTrue(map.size() == 0);
    }

    @Test
    public void testContainsPass(){
        MyMap<String, String> map = new MyMap<>();
        map.put("jonathan", "hinds");
        Assert.assertTrue(map.containsKey("jonathan"));
    }

    @Test
    public void testContainsFail(){
        MyMap<String, String> map = new MyMap<>();
        map.put("jonathan", "hinds");
        Assert.assertFalse(map.containsKey("hinds"));
    }

    @Test
    public void testKeySet(){
        MyMap<String, String> map = new MyMap<>();
        map.put("jonathan", "hinds");
        map.put("someother", "example");
        String[] expect = {"jonathan", "someother"};
        Assert.assertEquals(Arrays.toString(expect), Arrays.toString(map.keySet()));
    }
}
