import org.junit.Assert;
import org.junit.Test;

public class MySetTest {

    @Test
    public void testAddPass(){
        MySet<Integer> set = new MySet<>();
        Assert.assertTrue(set.add(10));
    }

    @Test
    public void testAddFail(){
        MySet<Integer> set = new MySet<>();
        set.add(10);
        Assert.assertFalse(set.add(10));
    }

    @Test
    public void addAllTest(){
        MyArrayList<Integer> list = new MyArrayList<>();
        for(int i = 0; i < 10; i ++){
            list.add(i);
        }

        MySet<Integer> set = new MySet<Integer>();
        set.addAll(list);
        Assert.assertTrue(set.size() == 10);
    }

    @Test
    public void addAllDuplicateTest(){
        MyArrayList<Integer> list = new MyArrayList<>();
        for(int i = 0; i < 10; i ++){
            list.add(10);
        }

        MySet<Integer> set = new MySet<Integer>();
        set.addAll(list);
        Assert.assertTrue(set.size() == 1);
    }

    @Test
    public void testIsEmptyPass(){
        MySet<Integer> set = new MySet();
        Assert.assertTrue(set.isEmpty());
    }

    @Test
    public void testIsEmptyFail(){
        MySet<Integer> set = new MySet();
        set.add(10);
        Assert.assertFalse(set.isEmpty());
    }

    @Test
    public void testToArray(){
        MySet<Integer> set = new MySet<>();
        set.add(10);
        set.add(12);
        Integer[] temp = set.toArray(new Integer[set.size()]);
        int actual = temp.length;
        int expect = 2;
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void getTest(){
        MySet<Integer> set = new MySet<>();
        set.add(10);
        int expect = 10;
        int actual = set.get(0);
        Assert.assertEquals(expect, actual);
    }

    @Test
    public void testContains(){
        MySet<Integer> set = new MySet<>();
        set.add(10);
        Assert.assertTrue(set.contains(10));
    }
}
